package example.comanche;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

public class RequestDispatcher implements RequestHandler , BindingController {

    private Map handlers = new TreeMap();
    
    public void handleRequest(Request r) throws IOException {
        Iterator i = handlers.values().iterator();
        while (i.hasNext()) {
            try {
                ((RequestHandler)(i.next())).handleRequest(r);
                return ;
            } catch (IOException _) {
            }
        }
    }
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
        if (clientItfName.startsWith("h")) {
            if (!(RequestHandler.class.isAssignableFrom(serverItf.getClass()))) {
                throw new IllegalBindingException(((("server interfaces connected to " + clientItfName) + " must be instances of ") + (RequestHandler.class.getName())));
            } 
            handlers.put(clientItfName ,serverItf);
            return ;
        } 
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }
    
    public String[] listFc() {
        List __interfaces__ = new ArrayList();
        __interfaces__.addAll(handlers.keySet());
        return ((String[])(__interfaces__.toArray(new String[]{  })));
    }
    
    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException {
        if (clientItfName.startsWith(clientItfName)) {
            return handlers.get(clientItfName);
        } 
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }
    
    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
        if (handlers.containsKey(clientItfName)) {
            handlers.remove(clientItfName);
            return ;
        } 
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }
    
}